from typing import Annotated

from fastapi import APIRouter, Depends

from api.application.contracts.auth import UserCreateRequest
from api.application.usecase.auth.create_user import CreateUser
from api.infrastructure.dependencies.stub import Stub

auth_router = APIRouter(prefix="/auth", tags=["Auth"])


@auth_router.post("/register", status_code=201)
async def create_user(
    request: UserCreateRequest,
    usecase: Annotated[CreateUser, Depends(Stub(CreateUser))],
) -> None:
    return await usecase.execute(request)
